/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Event.xs. Do not edit this file, edit Event.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Event.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <assert.h>
#include <string.h>

#include "EventAPI.h"
#include "../Coro/CoroAPI.h"

#define CD_WAIT	0 /* wait queue */
#define CD_TYPE	1
#define CD_OK	2
#define CD_HITS	3 /* hardcoded in Coro::Event */
#define CD_GOT	4 /* hardcoded in Coro::Event, Coro::Handle */
#define CD_MAX	4

static HV *coro_event_event_stash;

static void
coro_std_cb (pe_event *pe)
{
  AV *priv = (AV *)pe->ext_data;
  IV type = SvIV (AvARRAY (priv)[CD_TYPE]);
  AV *cd_wait;
  SV *coro;

  SvIV_set (AvARRAY (priv)[CD_HITS], pe->hits);
  SvIV_set (AvARRAY (priv)[CD_GOT], type ? ((pe_ioevent *)pe)->got : 0);

  AvARRAY (priv)[CD_OK] = &PL_sv_yes;

  cd_wait = (AV *)AvARRAY(priv)[CD_WAIT];

  coro = av_shift (cd_wait);
  if (coro != &PL_sv_undef)
    {
      CORO_READY (coro);
      SvREFCNT_dec (coro);
    }

  if (av_len (cd_wait) < 0)
    GEventAPI->stop (pe->up, 0);
}

static void
asynccheck_hook (void *data)
{
  /* this loops as long as we have _other_ coros with the same or higher priority */
  while (CORO_NREADY && CORO_CEDE)
    ;
}

static double
prepare_hook (void *data)
{
  /* this yields once to another coro with any priority */
  if (CORO_NREADY)
    {
      CORO_CEDE_NOTSELF;
      /*
       * timers might have changed, and Event fails to notice this
       * so we have to assume the worst. If Event didn't have that bug,
       * we would only need to do this if CORO_NREADY is != 0 now.
       */
      return 0.;
    }
  else
    return 85197.73; /* this is as good as any value, but it factors badly with common values */
}

#line 82 "Event.c"
XS(XS_Coro__Event__install_std_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Coro__Event__install_std_cb)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Coro::Event::_install_std_cb(self, type)");
    {
	SV *	self = ST(0);
	int	type = (int)SvIV(ST(1));
#line 90 "Event.xs"
{
        pe_watcher *w = GEventAPI->sv_2watcher (self);

        if (w->callback)
          croak ("Coro::Event watchers must not have a callback (see Coro::Event), caught");

        {
          AV *priv = newAV ();

          av_fill (priv, CD_MAX);
          AvARRAY (priv)[CD_WAIT] = (SV *)newAV (); /* AV in AV _should_ not be exposed to perl */
          AvARRAY (priv)[CD_TYPE] = newSViv (type);
          AvARRAY (priv)[CD_OK  ] = &PL_sv_no;
          AvARRAY (priv)[CD_HITS] = newSViv (0);
          AvARRAY (priv)[CD_GOT ] = newSViv (0);
          SvREADONLY_on (priv);

          w->callback = coro_std_cb;
          w->ext_data = priv;

          /* make sure Event does not use PERL_MAGIC_uvar, which */
          /* we abuse for non-uvar purposes. */
          sv_magicext (SvRV (self), newRV_noinc ((SV *)priv), PERL_MAGIC_uvar, 0, 0, 0);
        }
}
#line 118 "Event.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Coro__Event__next); /* prototype to pass -Wmissing-prototypes */
XS(XS_Coro__Event__next)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Coro::Event::_next(self)");
    {
	SV *	self = ST(0);
#line 119 "Event.xs"
{
        pe_watcher *w = GEventAPI->sv_2watcher (self);
        AV *priv = (AV *)w->ext_data;

        if (AvARRAY (priv)[CD_OK] == &PL_sv_yes)
          {
            AvARRAY (priv)[CD_OK] = &PL_sv_no;
            XSRETURN_NO; /* got an event */
          }

        av_push ((AV *)AvARRAY (priv)[CD_WAIT], SvREFCNT_inc (CORO_CURRENT));

        if (!w->running)
          GEventAPI->start (w, 1);

        XSRETURN_YES; /* schedule */
}
#line 149 "Event.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_Coro__Event__event); /* prototype to pass -Wmissing-prototypes */
XS(XS_Coro__Event__event)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Coro::Event::_event(self)");
    {
	SV *	RETVAL;
	SV *	self = ST(0);
#line 140 "Event.xs"
{
        if (GIMME_V == G_VOID)
          XSRETURN_EMPTY;

        {
          pe_watcher *w = GEventAPI->sv_2watcher (self);
          AV *priv = (AV *)w->ext_data;

          RETVAL = newRV_inc ((SV *)priv);

          /* may need to bless it now */
          if (!SvOBJECT (priv))
            {
              SvREADONLY_off ((SV *)priv);
              sv_bless (RETVAL, coro_event_event_stash);
              SvREADONLY_on ((SV *)priv);
            }
        }
}
#line 183 "Event.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Coro__Event); /* prototype to pass -Wmissing-prototypes */
XS(boot_Coro__Event)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXSproto("Coro::Event::_install_std_cb", XS_Coro__Event__install_std_cb, file, "$$");
        newXSproto("Coro::Event::_next", XS_Coro__Event__next, file, "$");
        newXSproto("Coro::Event::_event", XS_Coro__Event__event, file, "$");

    /* Initialisation Section */

#line 77 "Event.xs"
{
	coro_event_event_stash = gv_stashpv ("Coro::Event::Event", TRUE);

        I_EVENT_API ("Coro::Event");
	I_CORO_API ("Coro::Event");

        GEventAPI->add_hook ("asynccheck", (void *)asynccheck_hook, 0);
        GEventAPI->add_hook ("prepare",    (void *)prepare_hook,    0);
}

#line 218 "Event.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

